Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90	(revision 3359)
@@ -509,13 +512,13 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE report_consistant(budgetstr,budgetunits,startstr,startval,endstr,endval)
+   SUBROUTINE report_consistant( cd_budgetstr, cd_budgetunits, cd_startstr, pstartval, cd_endstr, pendval)
       ! Arguments
-      CHARACTER*(*), INTENT(in) :: budgetstr, budgetunits, startstr, endstr
-      REAL(wp),      INTENT(in) :: startval, endval
-
-      WRITE(numicb,200) budgetstr//' check:', &
-                        startstr,startval,budgetunits, &
-                        endstr,endval,budgetunits, &
-                        'error',(endval-startval)/((endval+startval)+1e-30),'nd'
+      CHARACTER*(*), INTENT(in) :: cd_budgetstr, cd_budgetunits, cd_startstr, cd_endstr
+      REAL(wp),      INTENT(in) :: pstartval, pendval
+
+      WRITE(numicb,200) cd_budgetstr // ' check:',                 &
+                        cd_startstr,    pstartval, cd_budgetunits, &
+                        cd_endstr,      pendval,   cd_budgetunits, &
+                        'error',        (pendval-pstartval)/((pendval+pstartval)+1e-30), 'nd'
       200 FORMAT(a19,10(a18,"=",es14.7,x,a2,:,","))
    END SUBROUTINE report_consistant
@@ -523,14 +526,20 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE report_budget(budgetstr,budgetunits,instr,inval,outstr,outval,delstr,startval,endval)
+   SUBROUTINE report_budget( cd_budgetstr, cd_budgetunits, cd_instr, pinval, cd_outstr,   &
+      &                      poutval, cd_delstr, pstartval, pendval)
       ! Arguments
-      CHARACTER*(*), INTENT(in) :: budgetstr, budgetunits, instr, outstr, delstr
-      REAL(wp),      INTENT(in) :: inval, outval, startval, endval
-
-      WRITE(numicb,200) budgetstr//' budget:', &
-                        instr//' in',inval,budgetunits, &
-                        outstr//' out',outval,budgetunits, &
-                        'Delta '//delstr,inval-outval,budgetunits, &
-                        'error',((endval-startval)-(inval-outval))/max(1.e-30,max(abs(endval-startval),abs(inval-outval))),'nd'
+      CHARACTER*(*), INTENT(in) :: cd_budgetstr, cd_budgetunits, cd_instr, cd_outstr, cd_delstr
+      REAL(wp),      INTENT(in) :: pinval, poutval, pstartval, pendval
+      ! Local variables
+      REAL(wp)                  :: zval
+
+      zval = ( ( pendval - pstartval ) - ( pinval - poutval ) ) /   &
+             MAX( 1.e-30, MAX( abs( pendval - pstartval ) , ABS( pinval - poutval ) ) )
+
+      WRITE(numicb,200) cd_budgetstr // ' budget:', &
+                        cd_instr     // ' in',      pinval,         cd_budgetunits, &
+                        cd_outstr    // ' out',     poutval,        cd_budgetunits, &
+                        'Delta '     // cd_delstr,  pinval-poutval, cd_budgetunits, &
+                        'error',        zval,                       'nd'
       200 FORMAT(a19,3(a18,"=",es14.7,x,a2,:,","),a8,"=",es10.3,x,a2)
    END SUBROUTINE report_budget
@@ -538,13 +547,13 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE report_istate(budgetstr,startstr,startval,endstr,endval,delstr)
+   SUBROUTINE report_istate( cd_budgetstr, cd_startstr, pstartval, cd_endstr, pendval, cd_delstr)
       ! Arguments
-      CHARACTER*(*), INTENT(in) :: budgetstr, startstr, endstr, delstr
-      INTEGER,       INTENT(in) :: startval, endval
-
-      WRITE(numicb,100) budgetstr//' state:', &
-                        startstr//' start',startval, &
-                        endstr//' end',endval, &
-                        delstr//'Delta',endval-startval
+      CHARACTER*(*), INTENT(in) :: cd_budgetstr, cd_startstr, cd_endstr, cd_delstr
+      INTEGER,       INTENT(in) :: pstartval, pendval
+
+      WRITE(numicb,100) cd_budgetstr // ' state:',           &
+                        cd_startstr  // ' start', pstartval, &
+                        cd_endstr    // ' end',   pendval,   &
+                        cd_delstr    // 'Delta',  pendval-pstartval
       100 FORMAT(a19,3(a18,"=",i14,x,:,","))
    END SUBROUTINE report_istate
@@ -552,14 +561,15 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE report_ibudget(budgetstr,instr,inval,outstr,outval,delstr,startval,endval)
+   SUBROUTINE report_ibudget( cd_budgetstr, cd_instr, pinval, cd_outstr, poutval,   &
+      &                       cd_delstr, pstartval, pendval)
       ! Arguments
-      CHARACTER*(*), INTENT(in) :: budgetstr, instr, outstr, delstr
-      INTEGER,       INTENT(in) :: inval, outval, startval, endval
-
-      WRITE(numicb,200) budgetstr//' budget:', &
-                          instr//' in',inval, &
-                          outstr//' out',outval, &
-                          'Delta '//delstr,inval-outval, &
-                          'error',((endval-startval)-(inval-outval))
+      CHARACTER*(*), INTENT(in) :: cd_budgetstr, cd_instr, cd_outstr, cd_delstr
+      INTEGER,       INTENT(in) :: pinval, poutval, pstartval, pendval
+
+      WRITE(numicb,200) cd_budgetstr // ' budget:', &
+                        cd_instr     // ' in',      pinval, &
+                        cd_outstr    // ' out',     poutval, &
+                        'Delta '     // cd_delstr,  pinval-poutval, &
+                        'error',                    ( ( pendval - pstartval ) - ( pinval - poutval ) )
       200 FORMAT(a19,10(a18,"=",i14,x,:,","))
    END SUBROUTINE report_ibudget
Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdyn.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdyn.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbdyn.F90	(revision 3359)
@@ -13,9 +13,4 @@
    !!            -    !                            the broken one)
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !!   icb_init      : initialise
-   !!   icb_gen       : generate test icebergs
-   !!   icb_nam       : read iceberg namelist
-   !!----------------------------------------------------------------------
    USE par_oce        ! NEMO parameters
    USE dom_oce        ! NEMO ocean domain
@@ -29,5 +24,5 @@
    PRIVATE
 
-   PUBLIC   evolve_icebergs  ! routine called in xxx.F90 module
+   PUBLIC   evolve_icebergs  ! routine called in icbrun.F90 module
 
 CONTAINS
@@ -42,11 +37,11 @@
       !!----------------------------------------------------------------------
       !
-      REAL(wp)                        ::   uvel1 , vvel1 , u1, v1, ax1, ay1, xi1 , yj1
-      REAL(wp)                        ::   uvel2 , vvel2 , u2, v2, ax2, ay2, xi2 , yj2
-      REAL(wp)                        ::   uvel3 , vvel3 , u3, v3, ax3, ay3, xi3 , yj3
-      REAL(wp)                        ::   uvel4 , vvel4 , u4, v4, ax4, ay4, xi4 , yj4
-      REAL(wp)                        ::   uvel_n, vvel_n                  , xi_n, yj_n
-      REAL(wp)                        ::   zdt, zdt_2, zdt_6, e1, e2
-      LOGICAL                         ::   bounced
+      REAL(wp)                        ::   zuvel1 , zvvel1 , zu1, zv1, zax1, zay1, zxi1 , zyj1
+      REAL(wp)                        ::   zuvel2 , zvvel2 , zu2, zv2, zax2, zay2, zxi2 , zyj2
+      REAL(wp)                        ::   zuvel3 , zvvel3 , zu3, zv3, zax3, zay3, zxi3 , zyj3
+      REAL(wp)                        ::   zuvel4 , zvvel4 , zu4, zv4, zax4, zay4, zxi4 , zyj4
+      REAL(wp)                        ::   zuvel_n, zvvel_n                  , zxi_n, zyj_n
+      REAL(wp)                        ::   zdt, zdt_2, zdt_6, ze1, ze2
+      LOGICAL                         ::   ll_bounced
       TYPE(iceberg), POINTER          ::   berg
       TYPE(point)  , POINTER          ::   pt
@@ -77,19 +72,19 @@
          pt => berg%current_point
 
-         bounced = .false.
+         ll_bounced = .false.
 
 
          ! STEP 1 !
          ! ====== !
-         xi1 = pt%xi   ;   uvel1 = pt%uvel     !**   X1 in (i,j)  ;  V1 in m/s
-         yj1 = pt%yj   ;   vvel1 = pt%vvel
+         zxi1 = pt%xi   ;   zuvel1 = pt%uvel     !**   X1 in (i,j)  ;  V1 in m/s
+         zyj1 = pt%yj   ;   zvvel1 = pt%vvel
 
 
          !                                         !**   A1 = A(X1,V1)
-         CALL accel(        xi1, e1, uvel1, uvel1, ax1,     &
-            &        berg , yj1, e2, vvel1, vvel1, ay1, zdt_2 )
-         !
-         u1 = uvel1 / e1                           !**   V1 in d(i,j)/dt
-         v1 = vvel1 / e2
+         CALL accel(        zxi1, ze1, zuvel1, zuvel1, zax1,     &
+            &        berg , zyj1, ze2, zvvel1, zvvel1, zay1, zdt_2 )
+         !
+         zu1 = zuvel1 / ze1                           !**   V1 in d(i,j)/dt
+         zv1 = zvvel1 / ze2
 
          ! STEP 2 !
@@ -97,45 +92,48 @@
          !                                         !**   X2 = X1+dt/2*V1   ;   V2 = V1+dt/2*A1
          ! position using di/dt & djdt   !   V2  in m/s
-         xi2 = xi1 + zdt_2 * u1          ;   uvel2 = uvel1 + zdt_2 * ax1
-         yj2 = yj1 + zdt_2 * v1          ;   vvel2 = vvel1 + zdt_2 * ay1
-         !
-         CALL adjust_to_ground( xi2, xi1, u1, yj2, yj1, v1, bounced )
+         zxi2 = zxi1 + zdt_2 * zu1          ;   zuvel2 = zuvel1 + zdt_2 * zax1
+         zyj2 = zyj1 + zdt_2 * zv1          ;   zvvel2 = zvvel1 + zdt_2 * zay1
+         !
+         CALL adjust_to_ground( zxi2, zxi1, zu1,   &
+         &                      zyj2, zyj1, zv1, ll_bounced )
 
          !                                         !**   A2 = A(X2,V2)
-         CALL accel(        xi2, e1, uvel2, uvel1, ax2,    &
-            &        berg , yj2, e2, vvel2, vvel1, ay2, zdt_2 )
-         !
-         u2 = uvel2 / e1                           !**   V2 in d(i,j)/dt
-         v2 = vvel2 / e2
+         CALL accel(        zxi2, ze1, zuvel2, zuvel1, zax2,    &
+            &        berg , zyj2, ze2, zvvel2, zvvel1, zay2, zdt_2 )
+         !
+         zu2 = zuvel2 / ze1                           !**   V2 in d(i,j)/dt
+         zv2 = zvvel2 / ze2
          !
          ! STEP 3 !
          ! ====== !
          !                                         !**  X3 = X1+dt/2*V2  ;   V3 = V1+dt/2*A2; A3=A(X3)
-         xi3  = xi1  + zdt_2 * u2   ;   uvel3 = uvel1 + zdt_2 * ax2
-         yj3  = yj1  + zdt_2 * v2   ;   vvel3 = vvel1 + zdt_2 * ay2
-         !
-         CALL adjust_to_ground( xi3, xi1, u3, yj3, yj1, v3, bounced )
+         zxi3  = zxi1  + zdt_2 * zu2   ;   zuvel3 = zuvel1 + zdt_2 * zax2
+         zyj3  = zyj1  + zdt_2 * zv2   ;   zvvel3 = zvvel1 + zdt_2 * zay2
+         !
+         CALL adjust_to_ground( zxi3, zxi1, zu3,   &
+         &                      zyj3, zyj1, zv3, ll_bounced )
 
          !                                         !**   A3 = A(X3,V3)
-         CALL accel(        xi3, e1, uvel3, uvel1, ax3,    &
-            &        berg , yj3, e2, vvel3, vvel1, ay3, zdt )
-         !
-         u3 = uvel3 / e1                           !**   V3 in d(i,j)/dt
-         v3 = vvel3 / e2
+         CALL accel(        zxi3, ze1, zuvel3, zuvel1, zax3,    &
+            &        berg , zyj3, ze2, zvvel3, zvvel1, zay3, zdt )
+         !
+         zu3 = zuvel3 / ze1                           !**   V3 in d(i,j)/dt
+         zv3 = zvvel3 / ze2
 
          ! STEP 4 !
          ! ====== !
          !                                         !**   X4 = X1+dt*V3   ;   V4 = V1+dt*A3
-         xi4 = xi1 + zdt * u3   ;   uvel4 = uvel1 + zdt * ax3
-         yj4 = yj1 + zdt * v3   ;   vvel4 = vvel1 + zdt * ay3
-
-         CALL adjust_to_ground( xi4, xi1, u4, yj4, yj1, v4, bounced )
+         zxi4 = zxi1 + zdt * zu3   ;   zuvel4 = zuvel1 + zdt * zax3
+         zyj4 = zyj1 + zdt * zv3   ;   zvvel4 = zvvel1 + zdt * zay3
+
+         CALL adjust_to_ground( zxi4, zxi1, zu4,   &
+         &                      zyj4, zyj1, zv4, ll_bounced )
 
          !                                         !**   A4 = A(X4,V4)
-         CALL accel(        xi4, e1, uvel4, uvel1, ax4,    &
-            &        berg , yj4, e2, vvel4, vvel1, ay4, zdt )
-
-         u4 = uvel4 / e1                           !**   V4 in d(i,j)/dt
-         v4 = vvel4 / e2
+         CALL accel(        zxi4, ze1, zuvel4, zuvel1, zax4,    &
+            &        berg , zyj4, ze2, zvvel4, zvvel1, zay4, zdt )
+
+         zu4 = zuvel4 / ze1                           !**   V4 in d(i,j)/dt
+         zv4 = zvvel4 / ze2
 
          ! FINAL STEP !
@@ -143,17 +141,18 @@
          !                                         !**   Xn = X1+dt*(V1+2*V2+2*V3+V4)/6
          !                                         !**   Vn = V1+dt*(A1+2*A2+2*A3+A4)/6
-         xi_n   = pt%xi   + zdt_6 * (  u1  + 2.*(u2  + u3 ) + u4  )
-         yj_n   = pt%yj   + zdt_6 * (  v1  + 2.*(v2  + v3 ) + v4  )
-         uvel_n = pt%uvel + zdt_6 * (  ax1 + 2.*(ax2 + ax3) + ax4 )
-         vvel_n = pt%vvel + zdt_6 * (  ay1 + 2.*(ay2 + ay3) + ay4 )
-
-         CALL adjust_to_ground( xi_n, xi1, uvel_n, yj_n, yj1, vvel_n, bounced )
-
-         pt%uvel = uvel_n                        !** save in berg structure
-         pt%vvel = vvel_n
-         pt%xi   = xi_n
-         pt%yj   = yj_n
-
-         ! sga - update actual position
+         zxi_n   = pt%xi   + zdt_6 * (  zu1  + 2.*(zu2  + zu3 ) + zu4  )
+         zyj_n   = pt%yj   + zdt_6 * (  zv1  + 2.*(zv2  + zv3 ) + zv4  )
+         zuvel_n = pt%uvel + zdt_6 * (  zax1 + 2.*(zax2 + zax3) + zax4 )
+         zvvel_n = pt%vvel + zdt_6 * (  zay1 + 2.*(zay2 + zay3) + zay4 )
+
+         CALL adjust_to_ground( zxi_n, zxi1, zuvel_n,   &
+         &                      zyj_n, zyj1, zvvel_n, ll_bounced )
+
+         pt%uvel = zuvel_n                        !** save in berg structure
+         pt%vvel = zvvel_n
+         pt%xi   = zxi_n
+         pt%yj   = zyj_n
+
+         ! update actual position
          pt%lon  = bilin_x(glamt, pt%xi, pt%yj )
          pt%lat  = bilin(gphit, pt%xi, pt%yj, 'T', 0, 0 )
@@ -166,5 +165,6 @@
 
 
-   SUBROUTINE adjust_to_ground( pi, pi0, pu, pj, pj0, pv, bounced )
+   SUBROUTINE adjust_to_ground( pi, pi0, pu,   &
+      &                         pj, pj0, pv, ld_bounced )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE adjust_to_ground  ***
@@ -177,15 +177,12 @@
       REAL(wp), INTENT(in   )         ::   pi0, pj0   ! previous iceberg position
       REAL(wp), INTENT(inout)         ::   pu  , pv   ! current iceberg velocities
-      LOGICAL , INTENT(  out)         ::   bounced    ! bounced indicator
-      !
-      REAL(wp), PARAMETER ::   posn_eps = 0.05_wp     ! bouncing distance in (i,j) referential
+      LOGICAL , INTENT(  out)         ::   ld_bounced    ! bounced indicator
       !
       INTEGER  ::   ii, ii0
       INTEGER  ::   ij, ij0
-      INTEGER  ::   bounce_method
-      !!----------------------------------------------------------------------
-      !
-      bounced = .false.
-      bounce_method = 2
+      INTEGER  ::   ibounce_method
+      !!----------------------------------------------------------------------
+      !
+      ld_bounced = .FALSE.
       !
       ii0 = INT( pi0+0.5 )   ;   ij0 = INT( pj0+0.5 )       ! initial gridpoint position (T-cell)
@@ -204,5 +201,5 @@
       ! From here, berg have reach land: treat grounding/bouncing
       ! -------------------------------
-      bounced = .true.
+      ld_bounced = .TRUE.
 
       !! not obvious what should happen now
@@ -213,5 +210,6 @@
       !! of travel to zero; at a coastal boundary this has the effect of sliding the berg along the coast
 
-      SELECT CASE ( bounce_method )
+      ibounce_method = 2
+      SELECT CASE ( ibounce_method )
          CASE ( 1 )
             pi = pi0
@@ -233,6 +231,6 @@
 
 
-   SUBROUTINE accel(       xi, e1, uvel, uvel0, ax,                &
-      &             berg , yj, e2, vvel, vvel0, ay, dt )
+   SUBROUTINE accel(       pxi, pe1, puvel, puvel0, pax,                &
+      &             berg , pyj, pe2, pvvel, pvvel0, pay, pdt )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE accel  ***
@@ -243,125 +241,125 @@
       !!----------------------------------------------------------------------
       TYPE(iceberg ), POINTER           ::   berg
-      REAL(wp), INTENT(in   )           ::   xi   , yj      ! berg position in (i,j) referential
-      REAL(wp), INTENT(in   )           ::   uvel , vvel    ! berg velocity [m/s]
-      REAL(wp), INTENT(in   )           ::   uvel0, vvel0   ! initial berg velocity [m/s]
-      REAL(wp), INTENT(  out)           ::   e1, e2         ! horizontal scale factor at (xi,yj)
-      REAL(wp), INTENT(inout)           ::   ax, ay         ! berg acceleration
-      REAL(wp), INTENT(in   )           ::   dt             ! berg time step
-      !
-      REAL(wp), PARAMETER ::   alpha     = 0._wp      !
-      REAL(wp), PARAMETER ::   beta      = 1._wp      !
-      REAL(wp), PARAMETER ::   vel_lim   =15._wp      ! max allowed berg speed
-      REAL(wp), PARAMETER ::   accel_lim = 1.e-2_wp   ! max allowed berg acceleration
-      REAL(wp), PARAMETER ::   Cr0       = 0.06_wp    !
+      REAL(wp), INTENT(in   )           ::   pxi   , pyj      ! berg position in (i,j) referential
+      REAL(wp), INTENT(in   )           ::   puvel , pvvel    ! berg velocity [m/s]
+      REAL(wp), INTENT(in   )           ::   puvel0, pvvel0   ! initial berg velocity [m/s]
+      REAL(wp), INTENT(  out)           ::   pe1, pe2         ! horizontal scale factor at (xi,yj)
+      REAL(wp), INTENT(inout)           ::   pax, pay         ! berg acceleration
+      REAL(wp), INTENT(in   )           ::   pdt             ! berg time step
+      !
+      REAL(wp), PARAMETER ::   pp_alpha     = 0._wp      !
+      REAL(wp), PARAMETER ::   pp_beta      = 1._wp      !
+      REAL(wp), PARAMETER ::   pp_vel_lim   =15._wp      ! max allowed berg speed
+      REAL(wp), PARAMETER ::   pp_accel_lim = 1.e-2_wp   ! max allowed berg acceleration
+      REAL(wp), PARAMETER ::   pp_Cr0       = 0.06_wp    !
       !
       INTEGER  ::   itloop
-      REAL(wp) ::   uo, vo, ui, vi, ua, va, uwave, vwave, ssh_x, ssh_y, sst, cn, hi
-      REAL(wp) ::   zff, T, D, W, L, M, F
-      REAL(wp) ::   drag_ocn, drag_atm, drag_ice, wave_rad
-      REAL(wp) ::   c_ocn, c_atm, c_ice
-      REAL(wp) ::   ampl, wmod, Cr, Lwavelength, Lcutoff, Ltop
-      REAL(wp) ::   lambda, detA, A11, A12, axe, aye, D_hi
-      REAL(wp) ::   uveln, vveln, us, vs, speed, loc_dx, new_speed
+      REAL(wp) ::   zuo, zvo, zui, zvi, zua, zva, zuwave, zvwave, zssh_x, zssh_y, zsst, zcn, zhi
+      REAL(wp) ::   zff, zT, zD, zW, zL, zM, zF
+      REAL(wp) ::   zdrag_ocn, zdrag_atm, zdrag_ice, zwave_rad
+      REAL(wp) ::   z_ocn, z_atm, z_ice
+      REAL(wp) ::   zampl, zwmod, zCr, zLwavelength, zLcutoff, zLtop
+      REAL(wp) ::   zlambda, zdetA, zA11, zA12, zaxe, zaye, zD_hi
+      REAL(wp) ::   zuveln, zvveln, zus, zvs, zspeed, zloc_dx, zspeed_new
       !!----------------------------------------------------------------------
 
       ! Interpolate gridded fields to berg
-      knberg = berg%number(1)
-      CALL interp_flds( xi, e1, uo, ui, ua, ssh_x,                     &
-         &              yj, e2, vo, vi, va, ssh_y, sst, cn, hi, zff )
-
-      M = berg%current_point%mass
-      T = berg%current_point%thickness                           ! total thickness
-      D = ( rn_rho_bergs / rho_seawater ) * T   ! draught (keel depth)
-      F = T - D                                    ! freeboard
-      W = berg%current_point%width
-      L = berg%current_point%length
-
-      hi   = MIN( hi   , D    )
-      D_hi = MAX( 0._wp, D-hi )
+      nknberg = berg%number(1)
+      CALL interp_flds( pxi, pe1, zuo, zui, zua, zssh_x,                     &
+         &              pyj, pe2, zvo, zvi, zva, zssh_y, zsst, zcn, zhi, zff )
+
+      zM = berg%current_point%mass
+      zT = berg%current_point%thickness                           ! total thickness
+      zD = ( rn_rho_bergs / pp_rho_seawater ) * zT   ! draught (keel depth)
+      zF = zT - zD                                    ! freeboard
+      zW = berg%current_point%width
+      zL = berg%current_point%length
+
+      zhi   = MIN( zhi   , zD    )
+      zD_hi = MAX( 0._wp, zD-zhi )
 
       ! Wave radiation
-      uwave = ua - uo   ;   vwave = va - vo     ! Use wind speed rel. to ocean for wave model
-      wmod  = uwave*uwave + vwave*vwave         ! The wave amplitude and length depend on the  current;
+      zuwave = zua - zuo   ;   zvwave = zva - zvo     ! Use wind speed rel. to ocean for wave model
+      zwmod  = zuwave*zuwave + zvwave*zvwave         ! The wave amplitude and length depend on the  current;
       !                                         ! wind speed relative to the ocean. Actually wmod is wmod**2 here.
-      ampl        = 0.5 * 0.02025 * wmod        ! This is "a", the wave amplitude
-      Lwavelength =       0.32    * wmod        ! Surface wave length fitted to data in table at
+      zampl        = 0.5 * 0.02025 * zwmod        ! This is "a", the wave amplitude
+      zLwavelength =       0.32    * zwmod        ! Surface wave length fitted to data in table at
       !                                         ! http://www4.ncsu.edu/eos/users/c/ceknowle/public/chapter10/part2.html
-      Lcutoff     = 0.125 * Lwavelength
-      Ltop        = 0.25  * Lwavelength
-      Cr          = Cr0 * MIN(  MAX( 0., (L-Lcutoff) / ((Ltop-Lcutoff)+1.e-30)) , 1.)  ! Wave radiation coefficient
+      zLcutoff     = 0.125 * zLwavelength
+      zLtop        = 0.25  * zLwavelength
+      zCr          = pp_Cr0 * MIN(  MAX( 0., (zL-zLcutoff) / ((zLtop-zLcutoff)+1.e-30)) , 1.)  ! Wave radiation coefficient
       !                                         ! fitted to graph from Carrieres et al.,  POAC Drift Model.
-      wave_rad    = 0.5 * rho_seawater / M * Cr * grav * ampl * MIN( ampl,F ) * (2.*W*L) / (W+L)
-      wmod        = SQRT( ua*ua + va*va )       ! Wind speed
-      IF( wmod /= 0._wp ) THEN
-         uwave = ua/wmod ! Wave radiation force acts in wind direction ...       !!gm  this should be the wind rel. to ocean ?
-         vwave = va/wmod
+      zwave_rad    = 0.5 * pp_rho_seawater / zM * zCr * grav * zampl * MIN( zampl,zF ) * (2.*zW*zL) / (zW+zL)
+      zwmod        = SQRT( zua*zua + zva*zva )       ! Wind speed
+      IF( zwmod /= 0._wp ) THEN
+         zuwave = zua/zwmod ! Wave radiation force acts in wind direction ...       !!gm  this should be the wind rel. to ocean ?
+         zvwave = zva/zwmod
       ELSE
-         uwave = 0.   ;    vwave=0.   ;    wave_rad=0. ! ... and only when wind is present.     !!gm  wave_rad=0. is useless
+         zuwave = 0.   ;    zvwave=0.   ;    zwave_rad=0. ! ... and only when wind is present.     !!gm  wave_rad=0. is useless
       ENDIF
 
       ! Weighted drag coefficients
-      c_ocn = rho_seawater / M * (0.5*Cd_wv*W*(D_hi)+Cd_wh*W*L)
-      c_atm = rho_air      / M * (0.5*Cd_av*W*F     +Cd_ah*W*L)
-      c_ice = rho_ice      / M * (0.5*Cd_iv*W*hi              )
-      IF( abs(ui) + abs(vi) == 0._wp )   c_ice = 0._wp
-
-      uveln = uvel   ;   vveln = vvel ! Copy starting uvel, vvel
+      z_ocn = pp_rho_seawater / zM * (0.5*pp_Cd_wv*zW*(zD_hi)+pp_Cd_wh*zW*zL)
+      z_atm = pp_rho_air      / zM * (0.5*pp_Cd_av*zW*zF     +pp_Cd_ah*zW*zL)
+      z_ice = pp_rho_ice      / zM * (0.5*pp_Cd_iv*zW*zhi              )
+      IF( abs(zui) + abs(zvi) == 0._wp )   z_ice = 0._wp
+
+      zuveln = puvel   ;   zvveln = pvvel ! Copy starting uvel, vvel
       !
       DO itloop = 1, 2  ! Iterate on drag coefficients
          !
-         us = 0.5 * ( uveln + uvel )
-         vs = 0.5 * ( vveln + vvel )
-         drag_ocn = c_ocn * SQRT( (us-uo)*(us-uo) + (vs-vo)*(vs-vo) )
-         drag_atm = c_atm * SQRT( (us-ua)*(us-ua) + (vs-va)*(vs-va) )
-         drag_ice = c_ice * SQRT( (us-ui)*(us-ui) + (vs-vi)*(vs-vi) )
+         zus = 0.5 * ( zuveln + puvel )
+         zvs = 0.5 * ( zvveln + pvvel )
+         zdrag_ocn = z_ocn * SQRT( (zus-zuo)*(zus-zuo) + (zvs-zvo)*(zvs-zvo) )
+         zdrag_atm = z_atm * SQRT( (zus-zua)*(zus-zua) + (zvs-zva)*(zvs-zva) )
+         zdrag_ice = z_ice * SQRT( (zus-zui)*(zus-zui) + (zvs-zvi)*(zvs-zvi) )
          !
          ! Explicit accelerations
-         !axe= zff*vvel -grav*ssh_x +wave_rad*uwave &
-         !    -drag_ocn*(uvel-uo) -drag_atm*(uvel-ua) -drag_ice*(uvel-ui)
-         !aye=-zff*uvel -grav*ssh_y +wave_rad*vwave &
-         !    -drag_ocn*(vvel-vo) -drag_atm*(vvel-va) -drag_ice*(vvel-vi)
-         axe = -grav * ssh_x + wave_rad * uwave
-         aye = -grav * ssh_y + wave_rad * vwave
-         IF( alpha > 0._wp ) THEN   ! If implicit, use time-level (n) rather than RK4 latest
-            axe = axe + zff*vvel0
-            aye = aye - zff*uvel0
+         !zaxe= zff*pvvel -grav*zssh_x +zwave_rad*zuwave &
+         !    -zdrag_ocn*(puvel-zuo) -zdrag_atm*(puvel-zua) -zdrag_ice*(puvel-zui)
+         !zaye=-zff*puvel -grav*zssh_y +zwave_rad*zvwave &
+         !    -zdrag_ocn*(pvvel-zvo) -zdrag_atm*(pvvel-zva) -zdrag_ice*(pvvel-zvi)
+         zaxe = -grav * zssh_x + zwave_rad * zuwave
+         zaye = -grav * zssh_y + zwave_rad * zvwave
+         IF( pp_alpha > 0._wp ) THEN   ! If implicit, use time-level (n) rather than RK4 latest
+            zaxe = zaxe + zff*pvvel0
+            zaye = zaye - zff*puvel0
          else
-            axe=axe+zff*vvel
-            aye=aye-zff*uvel
+            zaxe=zaxe+zff*pvvel
+            zaye=zaye-zff*puvel
          endif
-         if (beta>0.) then ! If implicit, use time-level (n) rather than RK4 latest
-            axe=axe-drag_ocn*(uvel0-uo) -drag_atm*(uvel0-ua) -drag_ice*(uvel0-ui)
-            aye=aye-drag_ocn*(vvel0-vo) -drag_atm*(vvel0-va) -drag_ice*(vvel0-vi)
+         if (pp_beta>0.) then ! If implicit, use time-level (n) rather than RK4 latest
+            zaxe=zaxe-zdrag_ocn*(puvel0-zuo) -zdrag_atm*(puvel0-zua) -zdrag_ice*(puvel0-zui)
+            zaye=zaye-zdrag_ocn*(pvvel0-zvo) -zdrag_atm*(pvvel0-zva) -zdrag_ice*(pvvel0-zvi)
          else
-            axe=axe-drag_ocn*(uvel-uo) -drag_atm*(uvel-ua) -drag_ice*(uvel-ui)
-            aye=aye-drag_ocn*(vvel-vo) -drag_atm*(vvel-va) -drag_ice*(vvel-vi)
+            zaxe=zaxe-zdrag_ocn*(puvel-zuo) -zdrag_atm*(puvel-zua) -zdrag_ice*(puvel-zui)
+            zaye=zaye-zdrag_ocn*(pvvel-zvo) -zdrag_atm*(pvvel-zva) -zdrag_ice*(pvvel-zvi)
          endif
 
          ! Solve for implicit accelerations
-         IF( alpha + beta > 0._wp ) THEN
-            lambda = drag_ocn + drag_atm + drag_ice
-            A11 = 1.+beta*dt*lambda
-            A12 = alpha*dt*zff
-            detA = 1._wp / ( A11*A11 + A12*A12 )
-            ax = detA * ( A11*axe+A12*aye )
-            ay = detA * ( A11*aye-A12*axe )
+         IF( pp_alpha + pp_beta > 0._wp ) THEN
+            zlambda = zdrag_ocn + zdrag_atm + zdrag_ice
+            zA11 = 1.+pp_beta*pdt*zlambda
+            zA12 = pp_alpha*pdt*zff
+            zdetA = 1._wp / ( zA11*zA11 + zA12*zA12 )
+            pax = zdetA * ( zA11*zaxe+zA12*zaye )
+            pay = zdetA * ( zA11*zaye-zA12*zaxe )
          else
-            ax=axe   ;   ay=aye
+            pax=zaxe   ;   pay=zaye
          endif
 
-         uveln = uvel0 + dt*ax
-         vveln = vvel0 + dt*ay
+         zuveln = puvel0 + pdt*pax
+         zvveln = pvvel0 + pdt*pay
          !
       END DO      ! itloop
 
       IF( rn_speed_limit > 0.) THEN       ! Limit speed of bergs based on a CFL criteria (if asked)
-         speed = SQRT( uveln*uveln + vveln*vveln )    ! Speed of berg
-         IF( speed > 0.) THEN
-            loc_dx = MIN( e1, e2 )                          ! minimum grid spacing
-            new_speed = loc_dx / dt * rn_speed_limit     ! Speed limit as a factor of dx / dt
-            IF( new_speed < speed ) THEN
-               uveln = uveln * ( new_speed / speed )        ! Scale velocity to reduce speed
-               vveln = vveln * ( new_speed / speed )        ! without changing the direction
+         zspeed = SQRT( zuveln*zuveln + zvveln*zvveln )    ! Speed of berg
+         IF( zspeed > 0.) THEN
+            zloc_dx = MIN( pe1, pe2 )                          ! minimum grid spacing
+            zspeed_new = zloc_dx / pdt * rn_speed_limit     ! Speed limit as a factor of dx / dt
+            IF( zspeed_new < zspeed ) THEN
+               zuveln = zuveln * ( zspeed_new / zspeed )        ! Scale velocity to reduce speed
+               zvveln = zvveln * ( zspeed_new / zspeed )        ! without changing the direction
                CALL speed_budget()
             ENDIF
@@ -369,7 +367,7 @@
       ENDIF
       !                                      ! check the speed and acceleration limits
-      IF( ABS( uveln ) > vel_lim   .OR. ABS( vveln ) > vel_lim   )   &
+      IF( ABS( zuveln ) > pp_vel_lim   .OR. ABS( zvveln ) > pp_vel_lim   )   &
          WRITE(numicb,'("pe=",i3,x,a)') narea,'Dump triggered by excessive velocity'
-      IF( ABS( ax    ) > accel_lim .OR. ABS( ay    ) > accel_lim )   &
+      IF( ABS( pax    ) > pp_accel_lim .OR. ABS( pay    ) > pp_accel_lim )   &
          WRITE(numicb,'("pe=",i3,x,a)') narea,'Dump triggered by excessive acceleration'
       !
